// Created by cgo - DO NOT EDIT

//line cgo_unix.go:1
package net


import (
	"os"
	"syscall"
	"unsafe"
)

func cgoLookupHost(name string) (addrs []string, err os.Error, completed bool) {
	ip, err, completed := cgoLookupIP(name)
	for _, p := range ip {
		addrs = append(addrs, p.String())
	}
	return
}

func cgoLookupPort(net, service string) (port int, err os.Error, completed bool) {
	var res *_Ctype_struct_addrinfo
	var hints _Ctype_struct_addrinfo

	switch net {
	case "":

	case "tcp", "tcp4", "tcp6":
		hints.ai_socktype = _Cconst_SOCK_STREAM
		hints.ai_protocol = _Cconst_IPPROTO_TCP
	case "udp", "udp4", "udp6":
		hints.ai_socktype = _Cconst_SOCK_DGRAM
		hints.ai_protocol = _Cconst_IPPROTO_UDP
	default:
		return 0, UnknownNetworkError(net), true
	}
	if len(net) >= 4 {
		switch net[3] {
		case '4':
			hints.ai_family = _Cconst_AF_INET
		case '6':
			hints.ai_family = _Cconst_AF_INET6
		}
	}

	s := _Cfunc_CString(service)
	defer _Cfunc_free(unsafe.Pointer(s))
	if _Cfunc_getaddrinfo(nil, s, &hints, &res) == 0 {
		defer _Cfunc_freeaddrinfo(res)
		for r := res; r != nil; r = r.ai_next {
			switch r.ai_family {
			default:
				continue
			case _Cconst_AF_INET:
				sa := (*syscall.RawSockaddrInet4)(unsafe.Pointer(r.ai_addr))
				p := (*[2]byte)(unsafe.Pointer(&sa.Port))
				return int(p[0])<<8 | int(p[1]), nil, true
			case _Cconst_AF_INET6:
				sa := (*syscall.RawSockaddrInet6)(unsafe.Pointer(r.ai_addr))
				p := (*[2]byte)(unsafe.Pointer(&sa.Port))
				return int(p[0])<<8 | int(p[1]), nil, true
			}
		}
	}
	return 0, &AddrError{"unknown port", net + "/" + service}, true
}

func cgoLookupIPCNAME(name string) (addrs []IP, cname string, err os.Error, completed bool) {
	var res *_Ctype_struct_addrinfo
	var hints _Ctype_struct_addrinfo

	hints.ai_flags = (_Cconst_AI_ALL | _Cconst_AI_V4MAPPED | _Cconst_AI_CANONNAME) & cgoAddrInfoMask()

	h := _Cfunc_CString(name)
	defer _Cfunc_free(unsafe.Pointer(h))
	gerrno, err := _C2func_getaddrinfo(h, nil, &hints, &res)
	if gerrno != 0 {
		var str string
		if gerrno == _Cconst_EAI_NONAME {
			str = noSuchHost
		} else if gerrno == _Cconst_EAI_SYSTEM {
			str = err.String()
		} else {
			str = _Cfunc_GoString(_Cfunc_gai_strerror(gerrno))
		}
		return nil, "", &DNSError{Error: str, Name: name}, true
	}
	defer _Cfunc_freeaddrinfo(res)
	if res != nil {
		cname = _Cfunc_GoString(res.ai_canonname)
		if cname == "" {
			cname = name
		}
		if len(cname) > 0 && cname[len(cname)-1] != '.' {
			cname += "."
		}
	}
	for r := res; r != nil; r = r.ai_next {

		if r.ai_socktype != _Cconst_SOCK_STREAM {
			continue
		}
		switch r.ai_family {
		default:
			continue
		case _Cconst_AF_INET:
			sa := (*syscall.RawSockaddrInet4)(unsafe.Pointer(r.ai_addr))
			addrs = append(addrs, copyIP(sa.Addr[:]))
		case _Cconst_AF_INET6:
			sa := (*syscall.RawSockaddrInet6)(unsafe.Pointer(r.ai_addr))
			addrs = append(addrs, copyIP(sa.Addr[:]))
		}
	}
	return addrs, cname, nil, true
}

func cgoLookupIP(name string) (addrs []IP, err os.Error, completed bool) {
	addrs, _, err, completed = cgoLookupIPCNAME(name)
	return
}

func cgoLookupCNAME(name string) (cname string, err os.Error, completed bool) {
	_, cname, err, completed = cgoLookupIPCNAME(name)
	return
}

func copyIP(x IP) IP {
	y := make(IP, len(x))
	copy(y, x)
	return y
}
