#line 7 "cgo_unix.go"
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>



// Usual nonsense: if x and y are not equal, the type will be invalid
// (have a negative array count) and an inscrutable error will come
// out of the compiler and hopefully mention "name".
#define __cgo_compile_assert_eq(x, y, name) typedef char name[(x-y)*(x-y)*-2+1];

// Check at compile time that the sizes we use match our expectations.
#define __cgo_size_assert(t, n) __cgo_compile_assert_eq(sizeof(t), n, _cgo_sizeof_##t##_is_not_##n)

__cgo_size_assert(char, 1)
__cgo_size_assert(short, 2)
__cgo_size_assert(int, 4)
typedef long long __cgo_long_long;
__cgo_size_assert(__cgo_long_long, 8)
__cgo_size_assert(float, 4)
__cgo_size_assert(double, 8)

#include <errno.h>
#include <string.h>

void
_cgo_45784e1f6900_Cfunc_gai_strerror(void *v)
{
	struct {
		int p0;
		char __pad4[4];
		const char* r;
	} *a = v;
	a->r = (const char*) gai_strerror(a->p0);
}

void
_cgo_45784e1f6900_C2func_getaddrinfo(void *v)
{
	int e;
	errno = 0;
	struct {
		char* p0;
		char* p1;
		struct addrinfo* p2;
		struct addrinfo** p3;
		int r;
		char __pad36[4];
		void *e[2]; /* os.Error */
	} *a = v;
	a->r = getaddrinfo(a->p0, a->p1, a->p2, a->p3);
	*(int*)(a->e) = errno;
}

void
_cgo_45784e1f6900_Cfunc_freeaddrinfo(void *v)
{
	struct {
		struct addrinfo* p0;
	} *a = v;
	freeaddrinfo(a->p0);
}

void
_cgo_45784e1f6900_Cfunc_getaddrinfo(void *v)
{
	struct {
		char* p0;
		char* p1;
		struct addrinfo* p2;
		struct addrinfo** p3;
		int r;
		char __pad36[4];
	} *a = v;
	a->r = getaddrinfo(a->p0, a->p1, a->p2, a->p3);
}

void
_cgo_45784e1f6900_Cfunc_free(void *v)
{
	struct {
		void* p0;
	} *a = v;
	free(a->p0);
}

